unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, math,
  Classes, Graphics, Controls, Forms,StdCtrls,
  Dialogs, GLWin32Viewer,
  GLCrossPlatform, BaseClasses, GLScene,
  GLCoordinates,
  GLObjects ;

type
  TForm1 = class(TForm)
    GLSceneViewer2: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    raiz: TGLDummyCube;
    LineaBase: TGLLines;

    Button1: TButton;
    Button2: TButton;
    Button3: TButton;

    procedure GLSceneViewer2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    px,py : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  GLDummyCube1.Position.SetPoint(0,0,0);
end;

procedure TForm1.GLSceneViewer2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;
end;

// cuadro
procedure TForm1.Button1Click(Sender: TObject);
begin
  LineaBase.LineWidth := 3;
  LineaBase.LineColor.SetColor(0,0,0.8);
  LineaBase.NodesAspect := lnaCube;
  LineaBase.NodeSize := 0.2;

  LineaBase.Nodes.AddNode(0,0,0);
  LineaBase.Nodes.AddNode(1,0,0);
  LineaBase.Nodes.AddNode(1,1,0);
  LineaBase.Nodes.AddNode(0,1,0);
  LineaBase.Nodes.AddNode(0,0,0);
end;

// una parabola
procedure TForm1.Button2Click(Sender: TObject);
var
  xx,yy,dx  : single;
begin

  LineaBase.LineWidth := 2;
  LineaBase.LineColor.SetColor(0,0,0.8);
  LineaBase.NodesAspect := lnaInvisible;

  xx := -2;
  dx := 0.2;
  repeat
    yy := xx*xx/2;
    LineaBase.Nodes.AddNode(xx,yy,0);
    xx := xx + dx;
  until (xx>2.0);

end;

// red
procedure TForm1.Button3Click(Sender: TObject);
var
  xx,yy,zz,dx,dz  : single;
  kk,NN           : integer;
  raya            : TGLLines;
begin
  zz := -3.0;
  dz :=  0.5;
  NN := ceil(1 + 6/0.5);

  // curvas
  for kk := 0 to NN - 1 do begin
    raya := TGLLines.Create(self);
    raya.Parent := raiz;
    raya.LineWidth := 2;
    raya.LineColor.SetColor(0.8,0,0);
    raya.NodesAspect := lnaInvisible;

    xx := -2; dx := 0.2;
    repeat
      yy := xx*xx/2;
      raya.Nodes.AddNode(xx,yy,zz);
      xx := xx + dx;
    until (xx>2.0);
    zz := zz + dz;
  end;
  // rectas
  xx := -2; dx := 0.2;
  repeat
    raya := TGLLines.Create(self);
    raya.Parent := raiz;
    raya.LineWidth := 2;
    raya.LineColor.SetColor(0.8,0,0);
    raya.NodesAspect := lnaInvisible;

    yy := xx*xx/2;
    raya.Nodes.AddNode(xx,yy,-3);
    raya.Nodes.AddNode(xx,yy, 3);
    xx := xx + dx;
  until (xx>2.0);

end;

end.
